UNIT SIOS;

Interface
uses DOS, CRT;
const COM1 : Integer = $03F8;
      COM2 : Integer = $02F8;
      COM3 : Integer = $03E8;
      COM4 : Integer = $02E8;
var   BA : Integer;

procedure Init (COM: Integer);
procedure Sende (Zeichen :Byte);
function Empfang :Byte;
function Bereit: Boolean;
procedure Ausgabe (Wert : Byte);
function Eingabe: Byte;
function AnalogA: Byte;
function AnalogB: Byte;
function AnalogC: Byte;
function AnalogD: Byte;
procedure AnalogAusA (Wert: Byte);
procedure AnalogAusB (Wert: Byte);

Implementation

procedure Init (COM: Integer);
var  i, Dummy :Byte;
begin
  BA := COM;
  Port[BA+3]:=128;
  Port[BA+0]:=6;  { 19200 Baud }
  Port[BA+1]:=0;
  Port[BA+3]:=7;  { 8-Bit, n-Parity, 2 Stopbits }
  Port[BA+1]:=0;  { keine Interrupts }
  Port[BA+4]:=0;  { DTR = 0, RTS = 0}
  for i:= 1 to 3 do
    Dummy:=Port[BA];   { UART leeren }
end;

procedure Sende (Zeichen :Byte);
begin
  while (Port[BA+5] AND 32) = 0 do;  { Sende-Halteregister leer? }
  Port[BA]:=Zeichen;
end;

function Empfang :Byte;
var  i :Word;
begin
  i:=0;
  while ((Port[BA+5] AND 1)=0) AND (i<3200) DO Inc(i);
  if i < 3200
  then Empfang := Port[BA]
  else Empfang := 0;
end;

function Bereit: Boolean;
begin
  Sende (1);
  If Empfang = 10 then Bereit := true
  else Bereit := false;
end;

procedure Ausgabe (Wert : Byte);
begin
  Sende (16);
  Sende (Wert);
end;

function Eingabe: Byte;
begin
  Sende (32);
  Eingabe := Empfang;
end;

function AnalogA: Byte;
begin
  Sende (48);
  AnalogA := Empfang;
end;

function AnalogB: Byte;
begin
  Sende (49);
  AnalogB := Empfang;
end;

function AnalogC: Byte;
begin
  Sende (50);
  AnalogC := Empfang;
end;

function AnalogD: Byte;
begin
  Sende (51);
  AnalogD := Empfang;
end;

procedure AnalogAusA (Wert: Byte);
begin
  Sende (64);
  Sende (Wert);
end;

procedure AnalogAusB (Wert: Byte);
begin
  Sende (65);
  Sende (Wert);
end;

begin
end.

