//Copmiliert mit BC 4.5
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <toolhelp.h>
#define  state(b)  (int)SendDlgItemMessage(dlg,b,BM_GETCHECK,0,NULL)

/* PROTOTYPEN HAUPTPROGRAMM */
int  PASCAL WinMain(HANDLE,HANDLE,LPSTR,int);
int  test_proc(HWND dlg, UINT msg, UINT wp, LONG lp);
void hndl_dialog(FARPROC proc, char *tree);

/* Prototypen zu SIOS */
double AnalogEin(int Kanal);             //Analogwert 1..4
void AnalogAus(int Kanal,double Spannung);
int DigitalEingabe(void);                //Eingang lesen
void DigitalAusgabe(int Datum);          //Ausgang setzen
int Empfang(void);                       //RS232 Empfang
int Init(void);                          //Schittstelle initialisieren
void Sende(int c);                       //RS232 Senden
unsigned long timer(void);

HANDLE Inst; 	//Globale Instanz
int com;     	//Globale Schnittstelle
int Out=0;	//Globaler Zustand Digital

/* HAUPTPROGRAMM */
#pragma argsused
int PASCAL WinMain(HANDLE Instance, HANDLE PrevInstance, LPSTR command, int show)
{Inst=Instance;
 hndl_dialog(test_proc,"DIALOG_1");  	//Nur eine Proc
 return 0;                           	//Und ferig
}

/* Dialog-Handler */
void hndl_dialog(proc,tree) FARPROC proc; char *tree;
{FARPROC lpproc = MakeProcInstance(proc,Inst);
 DialogBox(Inst,tree,0,lpproc);
 FreeProcInstance(lpproc);
}

/* Die Dialog-Prozedur */
#pragma argsused
_export test_proc(HWND dlg, UINT msg, UINT wp, LONG lp)
{static HFONT font;   			//!
 int i, Digital; char s[80];            //Lokales
 switch(msg)
 {case WM_INITDIALOG:
	   font=CreateFont(30,10,0,0,800,0,0,0,
		ANSI_CHARSET,OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
		FIXED_PITCH|FF_ROMAN,"Helv");
	   for(i=101;i<=104;i++)            //Font setzen
		SendDlgItemMessage(dlg,i,WM_SETFONT,font,FALSE);
	   Init();                          //SIOS initialisieren
	   SetTimer(dlg,0,250,NULL);        //Alle 250 ms anzeigen
	   return TRUE;
  case WM_CLOSE:
  case WM_DESTROY:
	   KillTimer(dlg,0);                //Timer freigeben
	   CloseComm(com);                  //RS232 freigeben
	   DeleteObject(font);              //Font  freigeben
	   EndDialog(dlg,TRUE);
	   return TRUE;
  case WM_TIMER:
	   for(i=1;i<=4;i++)                //Analoganzeige
	   {switch(i)
		{case 1:case 2: sprintf(s,"%4.2f V",AnalogEin(i));break;
		 default:sprintf(s,"%4.2f V",AnalogEin(i)/2.0);break; //0..2,5 Volt
		}
		SetDlgItemText(dlg,i+100,s);
	   }
	   Digital=DigitalEingabe();        //Digitalanzeige
	   SendDlgItemMessage(dlg,301,BM_SETCHECK,Digital & 1,NULL);
	   SendDlgItemMessage(dlg,302,BM_SETCHECK,Digital & 2,NULL);
	   SendDlgItemMessage(dlg,303,BM_SETCHECK,Digital & 4,NULL);
	   SendDlgItemMessage(dlg,304,BM_SETCHECK,Digital & 8,NULL);
	   SendDlgItemMessage(dlg,305,BM_SETCHECK,Digital & 16,NULL);
	   SendDlgItemMessage(dlg,306,BM_SETCHECK,Digital & 32,NULL);
	   SendDlgItemMessage(dlg,307,BM_SETCHECK,Digital & 64,NULL);
	   SendDlgItemMessage(dlg,308,BM_SETCHECK,Digital & 128,NULL);
	   break;
  case WM_COMMAND:
	   switch(wp)
	   {char s[256];double spannung;int i;
		case 201: case 202: case 203: case 204: //Die 8 Ausgnge
		case 205: case 206: case 207: case 208:
		 Digital=128*state(208)+64*state(207)+32*state(206)+16*state(205)
					   +8*state(204)+4*state(203)+2*state(202)+state(201);
		 if(Digital!=Out)Out=Digital;       //Global merken
		 DigitalAusgabe(Out);
		 break;
		case 501: case 502://Analoge Ausgabe
		 GetDlgItemText(dlg,wp,s,sizeof(s));           //Text Holen
		 for(i=0;i<strlen(s);i++)if(s[i]==',')s[i]='.';//Komma nach Punkt
		 sscanf(s,"%lf",&spannung);                    //Numerisch
		 if(spannung<0.0 || spannung>5.0)spannung=0;   //Hosentrger
		 AnalogAus(wp-500,spannung);
		 break;

	   }//COMMAND
	   return TRUE;
 }//msg
 return FALSE;
}

/***********************************************************/
unsigned long timer()
{TIMERINFO ti;
 ti.dwSize=sizeof(TIMERINFO);
 TimerCount(&ti);
 return ti.dwmsSinceStart;
}

int OpenCom(char *serial)
{DCB dcb; int com;
 com=OpenComm(serial,1,1);		//Laut B.Kainka
 memset(&dcb,0,sizeof(DCB));            //Alles auf 0
 dcb.Id=com;
 dcb.BaudRate	=19200;                 //Sios-Parameter
 dcb.ByteSize	=8;
 dcb.Parity	=NOPARITY;
 dcb.StopBits	=TWOSTOPBITS;
 dcb.RlsTimeout	=30;
 dcb.CtsTimeout	=30;
 dcb.DsrTimeout	=30;
 dcb.fBinary	=1;                     //Wichtig!
 SetCommState(&dcb);
 return com;
}

double AnalogEin(int Kanal)             //Analogwert 1..4
{Sende(0x30-1+Kanal);
 return (double)(Empfang()/51.0);
}

void AnalogAus(int Kanal,double Spannung)
{Sende(0x40-1+Kanal);
 Sende((int)(Spannung*51.0));
}

int DigitalEingabe(void)                //Eingang lesen
{Sende (0x20);
 return (Empfang());
}

void DigitalAusgabe(int Datum)          //Ausgang setzen
{Sende(0x10);
 Sende(Datum);
 Out=Datum;
}

int Empfang(void)                       //RS232 Empfang
{long t0;BYTE b[1];
 t0=timer();
 while(ReadComm(com,b,1)!=1)
  if(timer()>(t0+30L))return 0;         //TimeOut 30 ms
 return (int)(b[0]);
}

int Init(void)                          //SIOS initialisieren
{com=OpenCom("COM2");
 if(com<0)return 0;
 DigitalAusgabe(0x0); Out=0;
 AnalogAus(1,0);
 AnalogAus(2,0);
 return 1;
}

void Sende(int c)                       //RS232 Senden
{long t0=timer();
 while(TransmitCommChar(com,(BYTE)c) != 0)
 if(timer()>(t0+20L))return ;   	//Timeout 20 ms
}


